//+------------------------------------------------------------------+
//|                                                      Tandem2.mq5 |
//|                                 Copyright 2012, Evgeniy Trofimov |
//|                        https://login.mql5.com/ru/users/EvgeTrofi |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Evgeniy Trofimov"
#property link      "https://login.mql5.com/ru/users/EvgeTrofi"
#property version   "2.00"
#property tester_indicator "Ind_2 Line+1.ex5"
#include <EvgeTrofi\Tandem.mqh>
enum ENUM_FLAG_CLOSE{
   FLAG_CLOSE_CROSS, //   
   FLAG_CLOSE_PROFIT //  
};
input string Symbol1_Name = "EURUSD";     //  
input bool   Symbol1_Reverse = false;     //  
input string Symbol2_Name = "GBPUSD";     // 
input bool   Symbol2_Reverse = false;     //  
input int    Volatility_Period = 144;     //   
input ENUM_TANDEM_LOT Volatility_Method = TANDEM_LOT_LEONID553; //  
input double SignalDeviation = 0.130;     //       Ind_2 Line+1
input double LoadPercent = 6;             //  
input ulong  MagicNumber = 1333;          // 
input ENUM_FLAG_CLOSE FlagClose = FLAG_CLOSE_CROSS; //  
//+------------------------------------------------------------------+
int h2Line;   //  Ind_2 Line+1
int hATR1_;   //  ATR   
int hATR2_;   //  ATR   
CTandem T;    // 
//CTrade Trade; //   (   Tandem.mqh)
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){
   if(Volatility_Method==TANDEM_LOT_NONE) return(INIT_FAILED);
   h2Line = iCustom(Symbol1_Name, Period(), "Ind_2 Line+1", 
                    Symbol1_Name,
                    Symbol1_Reverse,
                    Symbol2_Name,
                    Symbol2_Reverse,
                    true,               //   
                    2,                  //    
                    Volatility_Period,  //  ATR
                    21,                 //  
                    8,                  //  
                    MODE_SMMA,          // 
                    PRICE_WEIGHTED,     // 
                    clrTeal);
   if(h2Line == INVALID_HANDLE){
      Print("    Ind_2 Line+1.ex5");
      return(INIT_FAILED);
   }
   if(Volatility_Method==TANDEM_LOT_LEONID553){
      hATR1_ = iATR(Symbol1_Name, Period(), Volatility_Period);
      if(hATR1_ == INVALID_HANDLE){
         Print("    ATR   ");
         return(INIT_FAILED);
      }
      hATR2_ = iATR(Symbol2_Name, Period(), Volatility_Period);
      if(hATR2_ == INVALID_HANDLE){
         Print("    ATR   ");
         return(INIT_FAILED);
      }
   }
   T.Symbol1 = Symbol1_Name;
   T.Symbol2 = Symbol2_Name;
   //Trade.SetExpertMagicNumber(MagicNumber);
   return(INIT_SUCCEEDED);
}//OnInit()
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
}//OnDeinit()
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){
   static datetime LastTime=0;
   datetime Arr[];
   if(MQL5InfoInteger(MQL5_TESTER)){
      if(CopyTime(Symbol1_Name,Period(),0,1,Arr)>0){
         if(LastTime==Arr[0]) return;
         LastTime=Arr[0];
      }
   }
   
   FUTURE_TRANSACTION FT[];
   CheckOpen(FT);
   T.BasketOpen(FT, MagicNumber);
   CheckClose(FT);
   T.BasketClose(FT, MagicNumber);
}//OnTick()
//+------------------------------------------------------------------+
//   ,   
//   ,    
void CheckOpen(FUTURE_TRANSACTION &FT[]){
   double L[];
   bool Trade=false;
   ArrayResize(FT, 0);
   //  ,      ?
   if(CopyBuffer(h2Line, /* */ 2, /**/ 1, /**/ 4,L)<=0){
      Print("     Ind_2 Line+1. : ",GetLastError());
      return;
   }
   //L[2] -   !     
   if(L[0]<L[1] && L[1]>L[2] && L[2]>L[3] && L[3]>SignalDeviation){ // 
      ArrayResize(FT, 2);
      FT[0].Sym = Symbol1_Name;
      FT[0].Type = 1;
      FT[1].Sym = Symbol2_Name;
      FT[1].Type = 0;
      Trade=true;
   }
   if(L[0]>L[1] && L[1]<L[2] && L[2]<L[3] && L[3]<-SignalDeviation){ // 
      ArrayResize(FT, 2);
      FT[0].Sym = Symbol1_Name;
      FT[0].Type = 0;
      FT[1].Sym = Symbol2_Name;
      FT[1].Type = 1;
      Trade=true;
   }
   if(!Trade) return;
   if(Symbol1_Reverse) {if(FT[0].Type == 0) FT[0].Type = 1; else FT[0].Type = 0;}
   if(Symbol2_Reverse) {if(FT[1].Type == 0) FT[1].Type = 1; else FT[1].Type = 0;}
   if(Volatility_Method==TANDEM_LOT_LEONID553){
      T.CalcVolumes(hATR1_,hATR2_);
   }else if(Volatility_Method==TANDEM_LOT_EDIK1975){
      T.CalcVolumes(Volatility_Period);
   }
   T.CalcLots(LoadPercent);
   FT[0].Lot = T.Lot1;
   FT[1].Lot = T.Lot2;
}//CheckOpen()
//+------------------------------------------------------------------+
void CheckClose(FUTURE_TRANSACTION &FT[]){
   ArrayResize(FT, 0);
   double L[];
   int i=0;
   //  ,      ?
   if(CopyBuffer(h2Line, /* */ 2, /**/ 1, /**/ 1,L)<=0){
      Print("     Ind_2 Line+1. : ",GetLastError());
      return;
   }
   CMoneyManagment MM;
   double lot = MM.GetCurrentLot(Symbol1_Name, MagicNumber);
   
   if(Symbol1_Reverse){
      if(L[0]>0 && lot<0) {
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol1_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 0; 
         i++;
      }else if(L[0]<0 && lot>0){
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol1_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 1; 
         i++;
      }
   }else{
      if(L[0]>0 && lot>0) {
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol1_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 1; 
         i++;
      }else if(L[0]<0 && lot<0){
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol1_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 0; 
         i++;
      }
   }
   
   lot = MM.GetCurrentLot(Symbol2_Name, MagicNumber);
   if(Symbol2_Reverse){
      if(L[0]>0 && lot>0) {
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol2_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 1; 
         i++;
      }else if(L[0]<0 && lot<0){
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol2_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 0; 
         i++;
      }
   }else{
      if(L[0]>0 && lot<0) {
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol2_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 0; 
         i++;
      }else if(L[0]<0 && lot>0){
         ArrayResize(FT, i+1);
         FT[i].Sym = Symbol2_Name;
         FT[i].Lot = MathAbs(lot);
         FT[i].Type= 1; 
         i++;
      }
   }
}//CheckClose()
//+------------------------------------------------------------------+
